# BSM2_GUI  
**Report 2 - 15.01.2025**  
**Amirreza Ebrahimikalarijani**  
**Supervisor: Jonas Miederer**  

During these weeks, I completed watching 9 courses related to our project on [Code with Mosh](https://codewithmosh.com/):  

| No. | Course Name                                    | Original Duration (hrs) | Study Time (hrs) |
|-----|-----------------------------------------------|--------------------------|------------------|
| 1   | Ultimate JavaScript Part 1: Fundamentals      | 5                        | 6                |
| 2   | Ultimate JavaScript Part 2: Advanced Topics   | 4                        | 5                |
| 3   | The Ultimate TypeScript Course                | 5                        | 6                |
| 4   | Ultimate HTML5 & CSS3 Series: Part 1          | 3                        | 4                |
| 5   | The Ultimate HTML5 & CSS3 Series: Part 2      | 5                        | 6                |
| 6   | The Ultimate Docker Course                    | 5                        | 6                |
| 7   | React 18 for Beginners                        | 8                        | 9                |
| 8   | Mastering Next.js 13 with TypeScript          | 5                        | 6                |
| 9   | Mastering JavaScript Unit Testing             | 4                        | 5                |
| **Total** |                                           | **44**                  | **53**           |

You can find the dates in the related Google Sheet that I shared with you, and the certificates are attached (which also include dates by default).  

---

I believe covering this amount in this time frame isn't typical. So, how did I manage to study?  

If I had taken detailed notes, based on my experience, the total duration would have been approximately **160 hours** (53 × 3), which is incompatible with the nature of our project that needs to wrap up as quickly as possible. Therefore, I prioritized pace over quality at this stage. However, now I am familiar with various topics, and when it comes to discussing React or Next.js, I have a foundational understanding.  

At this point, I have the big picture and general ideas. If I encounter a specific topic during the project, I can revisit the courses and dive deeper because I at least know the scope of potential issues.  

---

I also created a simple demo project with a new structure to get a sense of how to implement our real project.  

This demo showcases a drag-and-drop calculator built with Next.js (React Flow) using React, TypeScript, and Python. Users can place input and operation nodes on a canvas, specify numeric values and the desired operation (e.g., addition, subtraction), then click a button to calculate. The Next.js API spawns a Python script, passing in the node data. The Python script performs the arithmetic and returns the result back to the frontend, providing a complete loop that demonstrates how more complex systems (like a mini Simulink) could be implemented.  


### Suggested Communication Process

1. **Frontend Interaction**:  
   - Users modify the input and operation nodes in the React Flow GUI.  
   - Upon clicking the "Run Calculation" button, the frontend sends a POST request to the backend at `http://localhost:3000/api/calculator` with the current nodes and edges data.  

2. **Backend Processing**:  
   - The Next.js API route (`route.ts`) receives the calculation request.  
   - It spawns a Python process, executing `calculator.py` and passing the nodes and edges data via stdin.  

3. **Python Simulation**:  
   - The Python script processes the input data, performing calculations based on the connected nodes and selected operations.  
   - It returns the calculation results as JSON to the backend.  

4. **Returning Results**:  
   - The backend sends the calculation results back to the frontend.  
   - The frontend displays the results in a user-friendly format below the "Run Calculation" button.  

---

### Planned Courses  

| No. | Course Name                                       | Original Duration (hrs) | Study Time (hrs) |
|-----|--------------------------------------------------|--------------------------|------------------|
| 1   | Ultimate HTML5 & CSS3 Series: Part 3             | 6                        |                  |
| 2   | Next.js: A Project                               | 7                        |                  |
| 3   | The Ultimate Redux Course                        | 6                        |                  |
| 4   | Testing React Apps with React Testing Library    | 7                        |                  |
| 5   | The Complete Node.js Course                      | 15                       |                  |
| 6   | The Ultimate Git Course                          | 6                        |                  |
| **Total** |                                              | **47**                  |                  |  
